<html>
  <head>
    <title>MF Options Calculator</title>
     <link href="https://fonts.googleapis.com/icon?family=Material+Icons" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/css/materialize.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/materialize/1.0.0/js/materialize.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/c3/0.7.0/c3.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/d3/5.8.0/d3.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/c3/0.7.0/c3.min.js"></script>
    <meta name="viewport" content="width=device-width, initial-scale=1.0"/>
    <meta charset="UTF-8">

    <script type="text/javascript">
      document.addEventListener('DOMContentLoaded', function() {
        const startel = document.getElementById('start_date');
        M.Datepicker.init(startel, {});

        function setId(el, n) {
          el.id = el.id + n;
          el.nextElementSibling.setAttribute("for", el.id);
        }
        function formatDate(date) {
            var d = new Date(date),
                month = ('0' + (d.getMonth() + 1)).slice(-2),
                day = ('0' + d.getDate()).slice(-2),
                year = d.getFullYear();

            return [year, month, day].join('-');
        }
        function addRow() {
          const template = document.getElementById("template");
          const rows = document.getElementById("rows");
          const cloned = template.content.cloneNode(true);
          const n = rows.childNodes.length;
          const countElm = cloned.getElementById("count");
          const initial_batch = cloned.getElementById("initial_batch");
          const batch = cloned.getElementById("batch");
          const final_batch = cloned.getElementById("final_batch");
          setId(countElm, n);
          setId(cloned.getElementById("price"), n);
          setId(cloned.getElementById("initial"), n);
          setId(initial_batch, n);
          setId(batch, n);
          setId(final_batch, n);
          M.Datepicker.init(cloned.getElementById("initial"+n), {});
          countElm.addEventListener("change", function (evt) {
            const count = parseInt(evt.target.value);
            const init = Math.floor((count / 3) + 0.25);
            const b = Math.round(count / 36);
            initial_batch.value = init;
            batch.value = b;
            final_batch.value = count - (23 * b + init);
          });
          rows.appendChild(cloned);
        }

        addRow();
        document.getElementById("add").addEventListener("click", addRow);

        function getDOM(initial) {
          return initial.getDate() > 28 ? 1 : initial.getDate();
        }

        function addMonths(initial, number) {
          const ret = new Date(initial);
          ret.setMonth(ret.getMonth() + number);
          return ret;
        }

        document.getElementById("form").addEventListener("submit", function(evt) {
          evt.preventDefault();
          const start_date = new Date(document.getElementById("start_date").value);
          const stock_value = parseFloat(document.getElementById("stock_value").value);
          const options = Array.from(document.querySelectorAll(".optionRow")).map(function (el) {
            return {
              count: parseInt(el.querySelector(".count").value),
              price: parseFloat(el.querySelector(".price").value),
              initial: new Date(el.querySelector(".initial").value),
              initial_batch: parseInt(el.querySelector(".initial_batch").value),
              batch: parseInt(el.querySelector(".batch").value),
              final_batch: parseInt(el.querySelector(".final_batch").value),
            };
          }).map(o => ({ ...o, dom: getDOM(o.initial), final_date: addMonths(o.initial, 24), batches: 0 }));
          console.log(options);
          const date = new Date(start_date);
          const schedule = [{ date: start_date, vest: 0, strike: 0, totalVest: 0, totalStrike: 0 }];
          while (options.some(o => o.count !== 0)) {
            const dom = date.getDate();
            const changes = options.filter(o => (formatDate(date) === formatDate(o.initial) || formatDate(date) === formatDate(o.final_date) || (o.dom === dom && o.batches < 23)) && formatDate(o.initial) <= formatDate(date) && o.count !== 0);
            if (changes.length > 0 || formatDate(date) === formatDate(new Date())) {
              const change = { date: new Date(date), vest: 0, strike: 0 };
              changes.forEach(option => {
                if (formatDate(date) === formatDate(option.initial)) {
                  option.count = option.count - option.initial_batch;
                  change.vest = change.vest + option.initial_batch;
                  change.strike = change.strike + (option.initial_batch * option.price);
                } else if (formatDate(date) === formatDate(option.final_date)) {
                  const vest = option.count;
                  option.count = 0;
                  change.vest = change.vest + vest;
                  change.strike = change.strike + (vest * option.price);
                } else if (dom === option.dom && option.batches < 23) {
                    const vest = Math.min(option.count, option.batch);
                    option.count = option.count - vest;
                    change.vest = change.vest + vest;
                    change.strike = change.strike + (vest * option.price);
                    option.batches = option.batches + 1;
                }
              });
              schedule.push({ ...change, totalVest: schedule[schedule.length - 1].totalVest + change.vest, totalStrike: schedule[schedule.length - 1].totalStrike+ change.strike })
            }
            date.setDate(date.getDate() + 1);
          }
          console.log(schedule);
          function calcValue(row) {
            return (row.totalVest * stock_value);
          }
          const current = schedule.find(o => formatDate(o.date) === formatDate(new Date()));
          document.getElementById("result").innerHTML = "";
          const summary = document.getElementById("summary");
          const cloned = summary.content.cloneNode(true);
          if (current.totalVest === 0) {
            cloned.getElementById("count").innerHTML += "<span>jack shit</span>";
            cloned.getElementById("gain").innerHTML += "<span>a whole heap of nothing</span>";
            cloned.getElementById("sold").innerHTML += "<span>£"+ ((schedule[schedule.length - 1].totalVest* stock_value) - schedule[schedule.length - 1].totalStrike).toFixed(2) +"</span>";
          } else {
            cloned.getElementById("count").innerHTML += "<span>" + current.totalVest + " options</span>";
            cloned.getElementById("gain").innerHTML += "<span>£" + (calcValue(current) - current.totalStrike).toFixed(2)+ "</span>";
            cloned.getElementById("sold").innerHTML += "<span>£"+ ((schedule[schedule.length - 1].totalVest* stock_value) - schedule[schedule.length - 1].totalStrike).toFixed(2) +"</span>";
          } 
          document.getElementById("result").appendChild(cloned);
          const tableTemp = document.getElementById("table");
          const table = tableTemp.content.cloneNode(true);
          document.getElementById("result").appendChild(table);
         
          schedule.forEach(r => {
            const rowtmp = document.getElementById("row");
            const row = rowtmp.content.cloneNode(true);
            row.querySelector(".date").innerHTML = formatDate(r.date);
            row.querySelector(".vest").innerHTML = r.totalVest;
            row.querySelector(".strike").innerHTML = "£"+r.totalStrike.toFixed(2);
            row.querySelector(".value").innerHTML = "£"+calcValue(r).toFixed(2);
            row.querySelector(".gain").innerHTML = "£"+(calcValue(r) - r.totalStrike).toFixed(2);
            document.getElementById("tbody").appendChild(row);
          });
          const charttmp = document.getElementById("chart");
          const chart = charttmp.content.cloneNode(true);
          document.getElementById("result").appendChild(chart);
          const data = schedule.map(r => ({ x: r.date, y: calcValue(r) - r.totalStrike }));
          const steps = [];
          data.forEach((point, i) => {
            if (i > 0) {
              steps.push({ x: point.x, y: data[i-1].y });
            }
            steps.push(point);
          });
          c3.generate({
            bindto: '#canvas',
            data: {
              colors: { y: "#26a69a" },
              x: 'x',
              columns: [
                ['x', ...steps.map(p => p.x)],
                ['y', ...steps.map(p => p.y)],
              ]
            },
            axis: {
              x: {
                type: 'timeseries',
                tick: {
                  format: '%Y-%m-%d'
                }
              }
            },
            legend: {
              show: false
            },
            tooltip: {
              format: {
                value: function (value, ratio, id, index) { return value.toFixed(2); }
              }
            }
          });
          return false;
         });
      });
    </script>
  </head>
  <body>
    <div class="container">
      <h2>MF Options Calculator</h2>
      <div class="row">
        <form class="col s12" action="" id="form">
          <div class="row">
            <h4>Basics</h4>
            <div class="row">
              <div class="input-field col s12">
                <input id="start_date" type="text" class="datepicker validate" required>
                <label for="start_date">MF Start Date</label>
              </div>
            </div>
            <div class="row">
              <div class="input-field col s12">
                <input id="stock_value" type="number" step="0.01" min="0.00" class="validate" required>
                <label for="stock_value">Share Value (£)</label>
                <small>Last Round: £69.71.</small>
              </div>
            </div>
          </div>
          <div class="row">
            <h4>Options</h4>
            <div id="rows">
              <template id="template">
                <div class="row optionRow">
                  <div class="input-field col s2">
                    <input id="count" type="number" class="count validate" required>
                    <label for="count">Total Number</label>
                  </div>
                  <div class="input-field col s2">
                    <input id="price" type="number" step="0.01" min="0.00" class="price validate" required>
                    <label for="price">Strike Price (£)</label>
                  </div>
                  <div class="input-field col s2">
                    <input id="initial" type="text" class="initial datepicker validate" required>
                    <label for="initial">Initial Vest Date</label>
                  </div>
                  <div class="input-field col s2">
                    <input id="initial_batch" type="number" class="initial_batch validate" required>
                    <label for="initial_batch">Initial Vest Size</label>
                  </div>
                  <div class="input-field col s2">
                    <input id="batch" type="number" class="batch validate" required>
                    <label for="batch">Vest Batch Size</label>
                  </div>
                  <div class="input-field col s2">
                    <input id="final_batch" type="number" class="final_batch validate" required>
                    <label for="final_batch">Final Vest Size</label>
                  </div>
                </div>
              </template>
            </div>
              <div class="row">
                <div class="col s12">
                  <a class="waves-effect waves-light btn" id="add"><i class="material-icons left">add</i>Add row</a>
                </div>
              </div>
          </div>
          <div class="row center">
            <button class="btn waves-effect waves-light" type="submit" name="action">
              Calculate
              <i class="material-icons right">send</i>
            </button>
          </div>
        </form>
      </div>

      <template id="summary">
        <div class="row center">
          <div class="col s4 center" id="count"><h5>Current Options</h5></div>
          <div class="col s4 center" id="gain"><h5>Exit Gain</h5></div>
          <div class="col s4 center" id="sold"><h5>If MF Sold</h5></div>
        </div>
      </template>
      <template id="table">
        <div class="row">
          <h5>Vesting schedule</h5>
          <table>
            <thead>
              <tr>
                <th>Date</th>
                <th>Total Vest</th>
                <th>Total Strike</th>
                <th>Exit Value</th>
                <th>Exit Gain</th>
              </tr>
            </thead>
            <tbody id="tbody">
            </tbody>
          </table>
      </template>
      <template id="row">
        <tr>
          <td class="date">Date</td>
          <td class="vest">Total Vested</td>
          <td class="strike">Total Strike</td>
          <td class="value">Exit Value</td>
          <td class="gain">Exit Gain</td>
        </tr>
      </template>
      <template id="chart">
        <div id="canvas" />
      </template>
      <div id="result" class="row">
      </div>
      <div class="row">
        <div class="col s12">
          <small>Note: The tool assumes you will exercise all of your vested options and then sell them all. Does not account for tax. Expect to lose 20% to CGT. There also has to be someone willing to buy them from the internal market.</small>
        </div>
      </div>
    </div>
  </body>
</html>